#include "Iter.H"
#include "List.H"



class EventLink
{
public:
	virtual void Forward() = 0;
};



template< class T >
class EventStub : public EventLink
{
public:
	EventStub( T* obs, void( T::*fun )() ) {
		_obs = obs;_fun = fun;
	}
	virtual void Forward() {
		( _obs->*_fun )();
	}
		
private:
	T* _obs;
	void ( T::*_fun )();
};



class StateChange
{
public:
	virtual void Register( EventLink* link ) {
		evLinks->Append( link );
	}
	virtual void Unregister( EventLink* link ) {
		evLinks->Remove( link );
	}
	virtual void Announce() {
		Iter< EventLink* > iter( evLinks );
		while ( EventLink* evLink = iter() ) {
			evLink->Forward();
		}
	}
	StateChange::StateChange() {
		evLinks = new List< EventLink* >();
	}
	
private:
	List< EventLink* >* evLinks;
};



