#ifndef _Events2_H
#define _Events2_H



#include "Iter.H"
#include "List.H"



template< class Arg1, class Arg2 >
class EventLink2
{
public:
	virtual void Forward( Arg1, Arg2 ) = 0;
};



template< class T, class Arg1, class Arg2 >
class EventStub2 : public EventLink2< Arg1, Arg2 >
{
public:
	EventStub2( T* obs, void( T::*fun )( Arg1, Arg2 ) ) {
		_obs = obs;_fun = fun;
	}
	virtual void Forward( Arg1 a1, Arg2 a2 ) {
		( _obs->*_fun )( a1, a2 );
	}
		
private:
	T* _obs;
	void ( T::*_fun )( Arg1, Arg2 );
};



template< class Arg1, class Arg2 >
class StateChange2
{
public:
	virtual void Register( EventLink2< Arg1, Arg2 >* link ) {
		evLinks->Append( link );
	}
	virtual void Unregister( EventLink2< Arg1, Arg2 >* link ) {
		evLinks->Remove( link );
	}
	virtual void Announce( Arg1 a1, Arg2 a2 ) {
		Iter< EventLink2< Arg1, Arg2 >* > iter( evLinks );
		while ( EventLink2< Arg1, Arg2 >* evLink = iter() ) {
			evLink->Forward( a1, a2 );
		}
	}
	StateChange2() {
		evLinks = new List< EventLink2< Arg1, Arg2 >* >();
	}
	
private:
	List< EventLink2< Arg1, Arg2 >* >* evLinks;
};



#endif
