#ifndef _Events3_H
#define _Events3_H



#include "List.H"
#include "Iter.H"



template< class Arg1, class Arg2, class Arg3 >
class EventLink3
{
public:
	virtual void Forward( Arg1, Arg2, Arg3 ) = 0;
};



template< class T, class Arg1, class Arg2, class Arg3 >
class EventStub3 : public EventLink3< Arg1, Arg2, Arg3 >
{
public:
	EventStub3( T* obs, void( T::*fun )( Arg1, Arg2, Arg3 ) ) {
		_obs = obs;_fun = fun;
	}
	virtual void Forward( Arg1 a1, Arg2 a2, Arg3 a3 ) {
		( _obs->*_fun )( a1, a2, a3 );
	}
		
private:
	T* _obs;
	void ( T::*_fun )( Arg1, Arg2, Arg3 );
};



template< class Arg1, class Arg2, class Arg3 >
class StateChange3
{
public:
	virtual void Register( EventLink3< Arg1, Arg2, Arg3 >* link ) {
		evLinks->Append( link );
	}
	virtual void Unregister( EventLink3< Arg1, Arg2, Arg3 >* link ) {
		evLinks->Remove( link );
	}
	virtual void Announce( Arg1 a1, Arg2 a2, Arg3 a3 ) {
		Iter< EventLink3< Arg1, Arg2, Arg3 >* > iter( evLinks );
		while ( EventLink3< Arg1, Arg2, Arg3 >* evLink = iter() ) {
			evLink->Forward( a1, a2, a3 );
		}
	}
	StateChange3() {
		evLinks = new List< EventLink3< Arg1, Arg2, Arg3 >* >();
	}
	
private:
	List< EventLink3< Arg1, Arg2, Arg3 >* >* evLinks;
};



#endif
