#include <iostream.h>
#include "Spreadsheet.H"
#include "Events1.H"
#include "Events3.H"


Item* Spreadsheet::GetCell( int x, int y ) { return &(_cells[x][y]); }
void Spreadsheet::Enter( Item* i, int x, int y ) { _cells[x][y] = *i; }
bool Spreadsheet::IsValidCell( int, int ) { return true; }

bool Spreadsheet::IsResult1Valid() { return true; }
Item* Spreadsheet::GetResult1() { &_result1; }

bool Spreadsheet::IsResult2Valid() { return true; }
Item* Spreadsheet::GetResult2() { &_result2; }

void Spreadsheet::Run()
{
	scCellChanged.Announce( &( _cells[1][1] = 42 ), 1, 1 );
	scCellChanged.Announce( &( _cells[1][2] = 37 ), 1, 2 );
	scCellChanged.Announce( &( _cells[1][3] = 11 ), 1, 3 );
	scCellChanged.Announce( &( _cells[1][4] = 11 ), 1, 4 );

	_result1 = 42 + 37 + 11 + 11;

	scResult1Valid.Announce( &_result1 );

	scCellChanged.Announce( &( _cells[2][1] = 47 ), 2, 1 );
	scCellChanged.Announce( &( _cells[2][2] = 11 ), 2, 2 );
	scCellChanged.Announce( &( _cells[2][3] = 17 ), 2, 3 );
	scCellChanged.Announce( &( _cells[2][4] = 13 ), 2, 4 );
	
	_result2 = 47 + 11 + 17 + 13;
	
	scResult2Valid.Announce( &_result2 );
}

Spreadsheet::Spreadsheet()
{
	scCellChanged = new StateChange3< Item*, int, int >();
	scResult1Valid = new StateChange1< Item* >();
	scResult2Valid = new StateChange1< Item* >();
}



void TabularView::CellChanged( Item* i, int x, int y )
{
	cout << "GraphView:\tItem at ("
		<< x << ", " << y << ")"
		<< " was set to " << *i << "." << endl;
}

void TabularView::Result1Valid( Item* r )
{
	cout << "TabularView:\tResult1 is " << *r << endl;
}

void TabularView::Result2Valid( Item* r )
{
	cout << "TabularView:\tResult2 is " << *r << endl;
}

TabularView::TabularView( Spreadsheet* ss )
{
	esCellChanged = new EventStub3< TabularView, Item*, int, int >(
		this, &TabularView::CellChanged );
	ss->scCellChanged->Register( esCellChanged );
	
	esResult1Valid = new EventStub1< TabularView, Item* >(
		this, &TabularView::Result1Valid );
	ss->scResult1Valid->Register( esResult1Valid );

	esResult2Valid = new EventStub1< TabularView, Item* >(
		this, &TabularView::Result2Valid );
	ss->scResult2Valid->Register( esResult2Valid );
}



void ResultView::Result1Valid( Item* r )
{
	cout << "ResultView:\tResult1 is " << *r << endl;
}

void ResultView::Result2Valid( Item* r )
{
	cout << "ResultView:\tResult2 is " << *r << endl;
}

ResultView::ResultView( Spreadsheet* ss)
{
	esResult1Valid = new EventStub1< ResultView, Item* >(
		this, &ResultView::Result1Valid );
	ss->scResult1Valid->Register( esResult1Valid );
	
	esResult2Valid = new EventStub1< ResultView, Item* >(
		this, &ResultView::Result2Valid );
	ss->scResult2Valid->Register( esResult2Valid );
}



void GraphView::CellChanged( Item* i, int x, int y )
{
	cout << "GraphView:\tItem at ("
		<< x << ", " << y << ")"
		<< " was set to " << *i << "." << endl;
}

GraphView::GraphView( Spreadsheet* ss )
{
	esCellChanged = new EventStub3< GraphView, Item*, int, int >(
		this, &GraphView::CellChanged );
	ss->scCellChanged->Register( esCellChanged );
}



