#include "bool.h"



typedef int Item;
#include "Events1.H"
#include "Events3.H"



class Spreadsheet
{
public:
		// operations for changed cell
	virtual bool IsValidCell( int x, int y );
	virtual Item* GetCell( int x, int y );
	StateChange3< Item*, int, int >* scCellChanged;
	virtual void Enter( Item*, int x, int y );
	
		// computable result 1
	virtual bool IsResult1Valid();
	virtual Item* GetResult1();
	StateChange1< Item* >* scResult1Valid;
	
		// computable result 2
	virtual bool IsResult2Valid();
	virtual Item* GetResult2();
	StateChange1< Item* >* scResult2Valid;
	
		// further operation ...
	virtual void Run();
	Spreadsheet();
	
private:
	Item _cells[64][64];
	Item _result1;
	Item _result2;
};



class TabularView
{
public:
		// dependencies on entered data
	EventLink3< Item*, int, int >* esCellChanged;
	virtual void CellChanged( Item*, int, int );
	EventLink1< Item* >* esResult1Valid;
	virtual void Result1Valid( Item* );
	EventLink1< Item* >* esResult2Valid;
	virtual void Result2Valid( Item* );
	
	TabularView( Spreadsheet* );
};



class ResultView
{
public:
		// dependencies on entered data
	EventLink1< Item* >* esResult1Valid;
	virtual void Result1Valid( Item* );
	EventLink1< Item* >* esResult2Valid;
	virtual void Result2Valid( Item* );
	
	ResultView( Spreadsheet* );
};



class GraphView
{
public:
		// dependencies on entered data
	EventLink3< Item*, int, int >* esCellChanged;
	virtual void CellChanged( Item*, int, int );
	
	GraphView( Spreadsheet* );
};

