#include "VoidIter.H"
#include "VoidList.H"





void* VoidIter::operator()()
{
	void* pItem = pList->Item( pCons );
	pCons = pList->Next( pCons );
	return pItem;
}


void* VoidIter::Item()
{
	return pList->Item( pCons );
}


void VoidIter::Insert( void* pObject )
{
	pCons = pList->Insert( pCons, pObject );
}


void VoidIter::Remove()
{
	if ( pCons != null ) pCons = pList->Remove( pCons );
}


void VoidIter::Remove( void* pObject )
{
	VoidCons* pCons = pList->Find( pObject );
	if ( pCons != null ) pList->Remove( pCons );
	pList->Drop( pCons );
}


bool VoidIter::Contains( void* pObject )
{
	VoidCons* pCons = pList->Find( pObject );
	pList->Drop( pCons );
	return pCons != null;
}


void VoidIter::Connect( VoidList& rList )
{
	pList = &rList;
	pCons = pList->Head();
}


void VoidIter::Disconnect()
{
	pList->Drop( pCons );
	pList = null;
}


VoidIter::VoidIter( VoidList& rList )
{
	Connect( rList );
}


VoidIter::~VoidIter()
{
	if ( pList != null ) Disconnect();
}

