#ifndef _VoidList_H
#define _VoidList_H

#include "bool.h"



	// cons cell used as a position pointer; it has an internal
	// reference count on numbers of iterators having requested it
class VoidCons;


	// list class for object/function pairs; nevertheless here
	// it has been left to work with void pointers
class VoidList
{
public:
		// retrieve current item
	void* Item( VoidCons* );

		// information access
	bool IsEmpty();

		// insert and remove operations
	VoidCons* Insert( VoidCons*, void* );
	VoidCons* Remove( VoidCons* );
	void Prepend( void* );
	void Append( void* );
	void Remove( void* );

		// operations for positioning
	VoidCons* Head();
	VoidCons* Tail();
	VoidCons* Next( VoidCons* );
	VoidCons* Previous( VoidCons* );
	VoidCons* Find( void* );

		// working with the list
	void Take( VoidCons* );
	void Drop( VoidCons* );

		// ctor and dtor
	VoidList();
	~VoidList();

private:
		// internal positioning
	VoidCons* NextValid( VoidCons* );
	VoidCons* PreviousValid( VoidCons* );

		// using a linked list of cons cells
	VoidCons* pHead;
	VoidCons* pTail;
};





#endif // _VoidList_H

